#include <iostream>
using namespace std;

int main() {
	int n,h;
	int pom=0, zs=-1;
	cin>>h>>n;
	int mat[h][n];
	int protok[n];
	for(int i = 0; i<h; i++){
		for(int j=0; j<n; j++){
			cin>>mat[i][j];
			protok[j]=1;
		}
	}
	
	for(int i = 0; i<h; i++){
		zs=-1;
		pom=0;
		for(int j=0; j<n; j++){
			if(mat[i][j]==0){
				pom+=protok[j];
				protok[j]=0;
			}
			else{ 
				if(zs==-1){	
					protok[j]+=pom;
					pom=0;
				}
				else{ 
					protok[zs]=protok[zs]+pom/2+((pom%2==1&&i%2==0)?1:0);
					protok[j]=protok[j]+pom/2+((pom%2==1&&i%2==1)?1:0);
					pom=0;
				}
				zs=j;	
			}	
			if(mat[i][j]==0 && pom!=0 && j==n-1){	
				protok[zs]+=pom;
				pom=0;
			}
		}
	}
	for(int i=0;i<n;i++){
		cout<<protok[i]<<" ";
	}
}